 PROGRAM implizite_Funktion_1;

 (* Es soll eine implizit gegebene Funktion gezeichnet werden:             *)
 (* gegebene Funktion ist z.B.:         X^4 + Y^4 = 50                     *)
 (* erster Schritt: X^4 + Y^4 - 50 = 0         Z = X^4 + Y^4 - 50          *)
 (* Es wird eine neue Funktion Z gebildet mit zwei unabhaengigen           *)
 (* Veraenderlichen X und Y. Jedem Wertepaar(X,Y) wird ein Z               *)
 (* zugeordnet. X,Y-Werte liegen in einer Ebene, Z-Werte bilden die        *)
 (* dritte Dimension. Jetzt werden einfach X, bezw. Y-Werte in einem vor-  *)
 (* gegebenen Bereich des Weltfensters durchprobiert und der Z-Wert  be-   *)
 (* rechnet.Das geschieht in zwei ineinandergeschachtelten Schleifen       *)
 (* Es duerfen aber nur jene Wertepaare(X,Y) gezeichnet werden,            *)
 (* die einen Z-Wert liefern, der in einer Epsilon Umgebung von            *)
 (* Null liegt, was ja durch die Ausgangsfunktion verlangt wird.           *)
 (* Ob ein Punkt in der Epsilon Umgebung liegt, wird  direkt durch         *)
 (* eine Wertabfrage mit dem Absolutbetrag von Z bewerkstelligt.           *)
 (* Die Genauigkeit des gezeichneten Graphen haengt also von der Groesse   *)
 (* von Epsilon und der Schrittweiten DX und DY ab.                        *)

USES CRT,GRAPH,WGRAPHIC;

  VAR
  I,J : INTEGER;
  X,Y,Z,Xun,Xob,Yun,Yob,Epsilon,DX,DY: REAL;
BEGIN
  WINITGRAPH(0,0,'');                      (* !!!! hier aendern !!!!   *)
  CLEARDEVICE;
  SetBkColor(15);
  SetColor(8);
  Xun := -5.0; Xob := 5.0;
  Yun := -5.0; Yob := 5.0;
  WORLDWINDOW(Xun,Xob,Yun,Yob);
  WHor(0.0,Xun,Xob); Whor(Xob,Xun,Xob); Whor(Xun,Xun,Xob);
  WVer(0.0,Yun,Yob); WVer(Xun,Yun,Yob); WVer(Xob,Yun,Yob);
  (*  Weltfenster gezeichnet   *)

  Epsilon := 3.0;              (* Genauigkeitsbereich und              *)
  DX := 0.04; DY := 0.04;      (* Schrittweiten ausprobieren           *)
  Y := Yun;
  WHILE (Y < Yob ) DO BEGIN
     X := Xun;
     WHILE (X < Xob) DO BEGIN
         (* ----------------------------------------------------- *)
         Z := ABS(X*X*X*X) + ABS(Y*Y*Y*Y) -50.0;
         (* ----------------------------------------------------- *)
         IF (ABS(Z) < Epsilon) THEN Wpixel(X,Y,9);
         X := X + DX;
     END;
     Y := Y + DY;
  END;
  WClosegraph;
END.
