  PROGRAM implizite_Funktion_3;

(* Unterschiede zur Version2 :                                             *)
(* gegenueber der zweiten Version waehlt man die Punktaufloesung           *)
(* in X-und Y-Richtung NX,NY. Die Schrittweiten DX,DY werden vom Programm  *)
(* berechnet. Die Schleifenzaehler sind ganzzahlig formuliert              *)

(* gegeben  ist die Funktion : Z = ((x-2)^2+(y-2)^2)*((x+2)^2+(y+2)^2)*    *)
(*                                 ((x-2)^2+(y+2)^2)*((x+2)^2+(y-2)^2)-M^2 *)
(* Diese Faktoren werden im Programm als F1,F2,F3 und F4 bezeichnet        *)
(* F1 = (x-2)^2 + (y-2)^2 usw.                                             *)

  USES CRT,GRAPH,WGRAPHIC;

  VAR
  I,J,NX,NY : INTEGER;
  X,XA,XB,X0,Y,YA,YB,Y0,Z,ZA,ZB,Z0,Xun,Xob,Yun,Yob,DX,DY: REAL;
  F1,F2,F3,F4,M                                         : REAL;

(* ---------------------- Hauptprogramm -------------------------------- *)

BEGIN
  WINITGRAPH(0,0,'');  (* !!!! hier aendern !!!!   *)
  CLEARDEVICE;
  SetBkColor(15);
  SetColor(7);
  Xun := -5.0; Xob := 5.0;
  Yun := -5.0; Yob := 5.0;
  WORLDWINDOW(Xun,Xob,Yun,Yob);
  WHor(0.0,Xun,Xob); Whor(Xob,Xun,Xob); Whor(Xun,Xun,Xob);
  WVer(0.0,Yun,Yob); WVer(Xun,Yun,Yob); WVer(Xob,Yun,Yob);
  (*  Weltfenster gezeichnet   *)

  (* NX Punktaufloesung in X-Richtung waehlen                              *)
  (* NY Punktaufloesung in Y-Richtung waehlen                              *)
  NX := 700; NY := 700;
  (* Schrittweiten werden berechnet                                        *)
  DX := (Xob-Xun)/NX; DY := (Yob-Yun)/NY;
  M := 63.99; (* gegebene Konstante in unserer Funktion                    *)

  (* ---------------- 1.ter Durchgang beginnt ---------------------------- *)
  Y := Yun;
  I := 0;
  WHILE (I < NY ) DO BEGIN
     XA := Xun + I*DX; XB := Xun + (I+1)*DX;
     J := 0;
     WHILE (J < NX) DO BEGIN
         (* ====================================== *)
         F1 := (XA-2.0)*(XA-2.0)+(Y-2.0)*(Y-2.0);
         F2 := (XA+2.0)*(XA+2.0)+(Y+2.0)*(Y+2.0);
         F3 := (XA-2.0)*(XA-2.0)+(Y+2.0)*(Y+2.0);
         F4 := (XA+2.0)*(XA+2.0)+(Y-2.0)*(Y-2.0);
         ZA := F1*F2*F3*F4-M*M;
         F1 := (XB-2.0)*(XB-2.0)+(Y-2.0)*(Y-2.0);
         F2 := (XB+2.0)*(XB+2.0)+(Y+2.0)*(Y+2.0);
         F3 := (XB-2.0)*(XB-2.0)+(Y+2.0)*(Y+2.0);
         F4 := (XB+2.0)*(XB+2.0)+(Y-2.0)*(Y-2.0);
         ZB := F1*F2*F3*F4-M*M;
         (* ====================================== *)
         IF Sgn(ZA) * Sgn(ZB) = -1 THEN BEGIN
            X0 := (XA*ZB - XB*ZA)/(ZB-ZA);
            WPixel(X0,Y,5);
         END;
         IF (Sgn(ZA)=0) AND (Sgn(ZB)=0) THEN BEGIN
            X0 := (XA + XB)/2;
            WPixel(X0,Y,5);
         END;
         IF (Sgn(ZA)=0) AND (Sgn(ZB)<>0) THEN BEGIN
            X0 := XA;
            WPixel(X0,Y,5);
         END;
         IF (Sgn(ZA)<>0) AND (Sgn(ZB)=0) THEN BEGIN
            X0 := XB;
            WPixel(X0,Y,5);
         END;
         XA := XB;
         XB := XA + DX;
         J := J + 1;
    END;
    Y := Y + DY;
    I := I + 1;
  END;
  (* --------------------- 2.ter Durchgang beginnt ----------------------- *)
  X := Xun;
  I := 0;
  WHILE (I < NX ) DO BEGIN
     YA := Yun + I*DY; YB := Yun + (I+1)*DY;
     J := 0;
     WHILE (J < NY) DO BEGIN
         (* ====================================== *)
         F1 := (X-2.0)*(X-2.0)+(YA-2.0)*(YA-2.0);
         F2 := (X+2.0)*(X+2.0)+(YA+2.0)*(YA+2.0);
         F3 := (X-2.0)*(X-2.0)+(YA+2.0)*(YA+2.0);
         F4 := (X+2.0)*(X+2.0)+(YA-2.0)*(YA-2.0);
         ZA := F1*F2*F3*F4-M*M;
         F1 := (X-2.0)*(X-2.0)+(YB-2.0)*(YB-2.0);
         F2 := (X+2.0)*(X+2.0)+(YB+2.0)*(YB+2.0);
         F3 := (X-2.0)*(X-2.0)+(YB+2.0)*(YB+2.0);
         F4 := (X+2.0)*(X+2.0)+(YB-2.0)*(YB-2.0);
         ZB := F1*F2*F3*F4-M*M;
         (* ====================================== *)
         IF Sgn(ZA) * Sgn(ZB) = -1 THEN BEGIN
            Y0 := (YA*ZB - YB*ZA)/(ZB-ZA);
            WPixel(X,Y0,5);
         END;
         IF (Sgn(ZA)=0) AND (Sgn(ZB)=0) THEN BEGIN
            Y0 := (YA + YB)/2;
            WPixel(X,Y0,5);
         END;
         IF (Sgn(ZA)=0) AND (Sgn(ZB)<>0) THEN BEGIN
            Y0 := YA;
            WPixel(X,Y0,5);
         END;
         IF (Sgn(ZA)<>0) AND (Sgn(ZB)=0) THEN BEGIN
            Y0 := YB;
            WPixel(X,Y0,5);
         END;
         YA := YB;
         YB := YA + DY;
         J := J + 1;
    END;
    X := X + DX;
    I := I + 1;
  END;
        
  WClosegraph;
END.
