


UNIT WGRAPHIC;
 INTERFACE
  USES CRT,GRAPH;
  FUNCTION Sgn(A : REAL) : INTEGER;
  PROCEDURE WINITGRAPH(DriverNr,ModeNr:INTEGER;PathtoDr:STRING);
  PROCEDURE WCLOSEGRAPH;  
  PROCEDURE WORLDWINDOW(Xmi,Xma,Ymi,Yma:REAL);
  PROCEDURE WPixel(X,Y:REAL;Col:WORD);
  PROCEDURE WLine(X1,Y1,X2,Y2 :REAL);
  PROCEDURE WMoveTo(X,Y:REAL);
  PROCEDURE WLineTo(X,Y:REAL);
  PROCEDURE WHor(Y,X1,X2:REAL);
  PROCEDURE WVer(X,Y1,Y2:REAL);
  PROCEDURE WBox(X1,Y1,X2,Y2:REAL);
  PROCEDURE WCircle(Xm,Ym,Ra:REAL);

IMPLEMENTATION
CONST
EPS = 1.0E-06;

VAR
  ScrFac                                             : REAL;
  MaxColor,MaxXScr,MaxYScr,XAsp,YAsp                 : WORD;
  GraphDriver,GraphMode                              : INTEGER;
  PathtoDriver                                       : STRING;
  Xmin,Xmax,Ymin,Ymax,Kx,Ky,
  XL,YL,W1X,W1Y                                      : REAL;
  Scr1X,Scr1Y,XScrL,YScrL,XSO,YSO                    : INTEGER;

FUNCTION Sgn(A : REAL) : INTEGER;
  BEGIN
  IF(ABS(A) < EPS) THEN BEGIN
      Sgn := 0;
  END ELSE BEGIN IF (A/ABS(A)) > 0 THEN BEGIN
             Sgn := 1;
           END ELSE BEGIN Sgn := -1;
               END;
           END;      
  END;

PROCEDURE WINITGRAPH(DriverNr,ModeNr:INTEGER;PathtoDr:STRING);
  BEGIN
  GraphDriver  := DriverNr;
  GraphMode    := ModeNr;
  PathtoDriver := PathtoDr;
  DetectGraph(GraphDriver,GraphMode);
  InitGraph(DriverNr,ModeNr,PathtoDriver);
  MaxXScr      := GetMaxX;
  MaxYScr      := GetMaxY;
  GetAspectRatio(XAsp,YAsp);
  ScrFac       := XAsp/YAsp;
  MaxColor     := GetMaxColor;
  END;  

PROCEDURE WCLOSEGRAPH;
  BEGIN
  SETCOLOR(7);
  LINE(MaxXScr-10,MaxYScr-10,MaxXScr-10,MaxYScr-30);
  LINE(MaxXScr-10,MaxYScr-30,MaxXScr-30,MaxYScr-30);
  LINE(MaxXScr-30,MaxYScr-30,MaxXScr-30,MaxYScr-10);
  LINE(MaxXScr-30,MaxYScr-10,MaxXScr-10,MaxYScr-10);
  LINE(MaxXScr-10,MaxYScr-10,MaxXScr-30,MaxYScr-30);
  LINE(MaxXScr-30,MaxYScr-10,MaxXScr-10,MaxYScr-30);
  REPEAT UNTIL KEYPRESSED;
  IF KEYPRESSED THEN CLOSEGRAPH;
END;                  

PROCEDURE WORLDWINDOW(Xmi,Xma,Ymi,Yma : REAL);
BEGIN
  Xmin  := Xmi;
  Xmax  := Xma;
  Ymin  := Ymi;
  Ymax  := Yma;
  IF((Xmin > Xmax) OR (Ymin > Ymax)) THEN BEGIN
    WRITELN('REDEFINE WORLDWINDOW !  RESTART PROGRAM');
    READLN;
  END;
  W1X   := Xmin;
  W1Y   := Ymin;
  XL    := Xmax - Xmin;
  YL    := Ymax - Ymin;
  XScrL := MaxXScr-1;
  YScrL := MaxYScr-1;
  IF XL/YL <= XScrL/YScrL*ScrFac THEN   BEGIN
  (* YL will be fitted according to XL  *)
     KY := YScrL/YL;
     KX := YScrL/(YL * ScrFac);
     XScrL := TRUNC(YScrL * XL/(YL * ScrFac) + 0.5);
     Scr1X := TRUNC((MaxXScr - XScrL)/2+ 0.5);
     Scr1Y := YScrL;
     XSO := TRUNC(Scr1X + KX*(-W1X)+ 0.5);
     YSO := TRUNC(Scr1Y - KY*(-W1Y)+ 0.5);

     END
     Else   BEGIN
  (* XL will be fitted according to YL  *)
     KX := XScrL/XL;
     KY := XScrL/XL * ScrFac;
     YScrL := TRUNC(XScrL * YL/XL * ScrFac + 0.5);
     Scr1X := MaxXScr - XScrL;
     Scr1Y := TRUNC(YScrL + (MaxYscr-YScrL)/2 + 0.5);
     XSO := TRUNC(Scr1X + KX*(-W1X)+ 0.5);
     YSO := TRUNC(Scr1Y - KY*(-W1Y)+ 0.5);
     END;
END;

PROCEDURE WPixel(X,Y : REAL; Col : WORD);
VAR
  ScrX,ScrY    : WORD;
  U,V          : REAL;
BEGIN
  IF X < Xmin THEN X := Xmin;
  IF X > Xmax THEN X := Xmax;
  IF Y < Ymin THEN Y := Ymin;
  IF Y > Ymax THEN Y := Ymax;
  U := Kx * ( X - W1X );
  V := Ky * ( W1Y - Y );
  ScrX := Scr1X + TRUNC(U + 0.5);
  ScrY := Scr1Y + TRUNC(V - 0.5);
  PutPixel(ScrX,ScrY,Col);         
(*  ScrX := XSO + TRUNC(KX * X +0.5);
  ScrY := YSO - TRUNC(KY * Y +0.5);
  PutPixel(ScrX,ScrY,Col);      *)
END;

PROCEDURE WLine(X1,Y1,X2,Y2 : REAL);
VAR
  ScrX1,ScrY1,ScrX2,ScrY2     : WORD;
  U1,V1,U2,V2                 : REAL;
BEGIN
  IF X1 < Xmin THEN X1 := Xmin;
  IF X1 > Xmax THEN X1 := Xmax;
  IF Y1 < Ymin THEN Y1 := Ymin;
  IF Y1 > Ymax THEN Y1 := Ymax;
  IF X2 < Xmin THEN X2 := Xmin;
  IF X2 > Xmax THEN X2 := Xmax;
  IF Y2 < Ymin THEN Y2 := Ymin;
  IF Y2 > Ymax THEN Y2 := Ymax;
  U1 := Kx * (X1 - W1X);
  U2 := Kx * (X2 - W1X);
  V1 := Ky * (W1Y - Y1);
  V2 := Ky * (W1Y - Y2);
  ScrX1 := Scr1X + TRUNC( U1 + 0.5);
  ScrX2 := Scr1X + TRUNC( U2 + 0.5);
  ScrY1 := Scr1Y + TRUNC( V1 - 0.5);
  ScrY2 := Scr1Y + TRUNC( V2 - 0.5);
  Line(ScrX1,ScrY1,ScrX2,ScrY2);
(*  ScrX1 := XSO + TRUNC(KX * X1 +0.5);
  ScrY1 := YSO - TRUNC(KY * Y1 +0.5);
  ScrX2 := XSO + TRUNC(KX * X2 +0.5);
  ScrY2 := YSO - TRUNC(KY * Y2 +0.5);
  setcolor(5);
  Line(ScrX1,ScrY1,ScrX2,ScrY2);
  setcolor(10);                *)
END;

PROCEDURE WMoveTo(X,Y : REAL);
VAR
  ScrX,ScrY           : WORD;
  U,V                 : REAL;
BEGIN
  IF X < Xmin THEN X := Xmin;
  IF X > Xmax THEN X := Xmax;
  IF Y < Ymin THEN Y := Ymin;
  IF Y > Ymax THEN Y := Ymax;
  U := Kx * ( X- W1X);
  V := Ky * (W1Y - Y);
  ScrX := Scr1X + TRUNC( U + 0.5 );
  ScrY := Scr1Y + TRUNC( V - 0.5 );
  MoveTo(ScrX,ScrY);
END;


PROCEDURE WLineTo(X,Y : REAL);
VAR
  ScrX,ScrY           : WORD;
  U,V                 : REAL;
BEGIN
  IF X < Xmin THEN X := Xmin;
  IF X > Xmax THEN X := Xmax;
  IF Y < Ymin THEN Y := Ymin;
  IF Y > Ymax THEN Y := Ymax;
  U := Kx * ( X- W1X);
  V := Ky * (W1Y - Y);
  ScrX := Scr1X + TRUNC( U + 0.5 );
  ScrY := Scr1Y + TRUNC( V - 0.5 );
  LineTo(ScrX,ScrY);
END;


PROCEDURE WHor(Y,X1,X2 : REAL);
BEGIN
  WMoveTo(X1,Y);
  WLineTo(X2,Y);
END;


PROCEDURE WVer(X,Y1,Y2 : REAL);
BEGIN
  WMoveTo(X,Y1);
  WLineTo(X,Y2);
END;

PROCEDURE WBox(X1,Y1,X2,Y2 : REAL);
BEGIN
  WHor(Y1,X1,X2);
  WHor(Y2,X1,X2);
  WVer(X1,Y1,Y2);
  WVer(X2,Y1,Y2);
END;

PROCEDURE WCircle(Xm,Ym,Ra : REAL);
VAR
  PHI,XCo,YCo,Circumf,a,b,c       : REAL;
BEGIN
 a := Xm; b :=Ym; c := Ra;
  WMoveTo(a + c,b);
  PHI := 0.0;
  Circumf := 2 * PI + 0.01;
  WHILE PHI < Circumf DO BEGIN
    XCo := a + COS(PHI) * c;
    YCo := b + SIN(PHI) * c;
       WLineTo( XCo,YCo);
    PHI := PHI + 0.01;
  END;
END;
(* ---------------- Initialisation ------------------- *)
BEGIN
END.